GNU bug report logs - #36830
26.2; find-file-visit-truename is not honored as file local variable

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Gustavo Barros <gusbrs.2016@HIDDEN>; Done: Lars Ingebrigtsen <larsi@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug closed, send any further explanations to 36830 <at> debbugs.gnu.org and Gustavo Barros <gusbrs.2016@HIDDEN> Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 14 Oct 2019 21:38:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 14 17:38:15 2019
Received: from localhost ([127.0.0.1]:42342 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iK82h-0008Rk-4w
	for submit <at> debbugs.gnu.org; Mon, 14 Oct 2019 17:38:15 -0400
Received: from [80.91.231.51] (port=41456 helo=quimby.gnus.org)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iK82f-0008Ra-NG
 for 36830 <at> debbugs.gnu.org; Mon, 14 Oct 2019 17:38:14 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iK82b-0004Sp-Iw; Mon, 14 Oct 2019 23:38:12 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36830: 26.2; find-file-visit-truename is not honored as
 file local variable
References: <87d0hufamm.fsf@HIDDEN> <87ftlsfp3v.fsf@HIDDEN>
 <87h8688233.fsf@HIDDEN> <874l27btck.fsf@HIDDEN>
 <83d0gvk5m0.fsf@HIDDEN> <87blwdajn2.fsf@HIDDEN>
 <83wof1hfaj.fsf@HIDDEN>
Date: Mon, 14 Oct 2019 23:38:09 +0200
In-Reply-To: <83wof1hfaj.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 25 Aug
 2019 10:31:32 +0300")
Message-ID: <87o8yjrose.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> So perhaps the fix
 here is to just remove that `put'? > > Fine with me. OK; done, and while
 there were other general issues about ordering of file-local variables
 discussed
 here, I think we're not going to make further progress on that in this context,
 so I'm closing this [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> So perhaps the fix
 here is to just remove that `put'? > > Fine with me. OK; done, and while
 there were other general issues about ordering of file-local variables
 discussed
 here, I think we're not going to make further progress on that in this context,
 so I'm closing this [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnu.org]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 1.3 RDNS_NONE Delivered to internal network by a host with no rDNS
X-Debbugs-Envelope-To: 36830
Cc: 36830 <at> debbugs.gnu.org, gusbrs.2016@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

>> So perhaps the fix here is to just remove that `put'?
>
> Fine with me.

OK; done, and while there were other general issues about ordering of
file-local variables discussed here, I think we're not going to make
further progress on that in this context, so I'm closing this bug
report.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 25 Aug 2019 07:31:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Aug 25 03:31:41 2019
Received: from localhost ([127.0.0.1]:43527 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1i1n00-0004mx-Oi
	for submit <at> debbugs.gnu.org; Sun, 25 Aug 2019 03:31:40 -0400
Received: from eggs.gnu.org ([209.51.188.92]:53523)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1i1mzz-0004mi-O3
 for 36830 <at> debbugs.gnu.org; Sun, 25 Aug 2019 03:31:40 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45777)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1i1mzu-0001KU-J2; Sun, 25 Aug 2019 03:31:34 -0400
Received: from [176.228.60.248] (port=2250 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1i1mzu-0005yZ-3e; Sun, 25 Aug 2019 03:31:34 -0400
Date: Sun, 25 Aug 2019 10:31:32 +0300
Message-Id: <83wof1hfaj.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87blwdajn2.fsf@HIDDEN> (message from Lars Ingebrigtsen on Sun, 
 25 Aug 2019 07:39:29 +0200)
Subject: Re: bug#36830: 26.2; find-file-visit-truename is not honored as
 file local variable
References: <87d0hufamm.fsf@HIDDEN> <87ftlsfp3v.fsf@HIDDEN>
 <87h8688233.fsf@HIDDEN> <874l27btck.fsf@HIDDEN>
 <83d0gvk5m0.fsf@HIDDEN> <87blwdajn2.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36830
Cc: 36830 <at> debbugs.gnu.org, gusbrs.2016@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: gusbrs.2016@HIDDEN,  36830 <at> debbugs.gnu.org
> Date: Sun, 25 Aug 2019 07:39:29 +0200
> 
> > Maybe we should just document that this variable cannot be file-local.
> 
> files.el has this:
> 
> (put 'find-file-visit-truename 'safe-local-variable 'booleanp)
> 
> It was changed to booleanp in 2007 (from the presumably invalid
> `boolean'), so it didn't work before 2007 for that reason, and it hasn't
> worked after 2007 because it's checked too late.
> 
> So perhaps the fix here is to just remove that `put'?

Fine with me.

> On the other hand, it would be nice if it worked, because it seems like
> a pretty useful thing to be able to customise on a per-file basis.

I agree.  If someone can come up with a way to resolve the race, I'm
all ears.

We have similar problems in startup.el, with variables that depend on
potentially customizable other variables, and the solutions are... not
pretty and quite fragile.  In particular, that kind of problems was
the main reason why we introduced the early-init file.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 25 Aug 2019 05:39:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Aug 25 01:39:35 2019
Received: from localhost ([127.0.0.1]:43459 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1i1lFX-00064w-ET
	for submit <at> debbugs.gnu.org; Sun, 25 Aug 2019 01:39:35 -0400
Received: from quimby.gnus.org ([80.91.231.51]:57738)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1i1lFV-00064o-SJ
 for 36830 <at> debbugs.gnu.org; Sun, 25 Aug 2019 01:39:34 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1i1lFS-0001Tz-7d; Sun, 25 Aug 2019 07:39:32 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36830: 26.2; find-file-visit-truename is not honored as
 file local variable
References: <87d0hufamm.fsf@HIDDEN> <87ftlsfp3v.fsf@HIDDEN>
 <87h8688233.fsf@HIDDEN> <874l27btck.fsf@HIDDEN>
 <83d0gvk5m0.fsf@HIDDEN>
Date: Sun, 25 Aug 2019 07:39:29 +0200
In-Reply-To: <83d0gvk5m0.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 23 Aug
 2019 23:07:51 +0300")
Message-ID: <87blwdajn2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > I don't think this
 variable was designed to be set from file-local > variables block. Visiting
 a file and naming its buffer are two racy > actions, and where there's a
 race there will be chicken-and [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36830
Cc: 36830 <at> debbugs.gnu.org, gusbrs.2016@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I don't think this variable was designed to be set from file-local
> variables block.  Visiting a file and naming its buffer are two racy
> actions, and where there's a race there will be chicken-and-egg type
> of problems.

[...]

> I expect such renaming to cause future bugs, FWIW.  Or maybe not, but
> this is beyond hacky, IMO.

Yes, I think so, too, but:

> Maybe we should just document that this variable cannot be file-local.

files.el has this:

(put 'find-file-visit-truename 'safe-local-variable 'booleanp)

It was changed to booleanp in 2007 (from the presumably invalid
`boolean'), so it didn't work before 2007 for that reason, and it hasn't
worked after 2007 because it's checked too late.

So perhaps the fix here is to just remove that `put'?

On the other hand, it would be nice if it worked, because it seems like
a pretty useful thing to be able to customise on a per-file basis.
Perhaps.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 23 Aug 2019 21:38:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 23 17:38:53 2019
Received: from localhost ([127.0.0.1]:41360 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1i1HGm-0004Bh-SI
	for submit <at> debbugs.gnu.org; Fri, 23 Aug 2019 17:38:53 -0400
Received: from mail-qt1-f193.google.com ([209.85.160.193]:45013)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gusbrs.2016@HIDDEN>) id 1i1HGk-0004BM-Js
 for 36830 <at> debbugs.gnu.org; Fri, 23 Aug 2019 17:38:50 -0400
Received: by mail-qt1-f193.google.com with SMTP id 44so12591300qtg.11
 for <36830 <at> debbugs.gnu.org>; Fri, 23 Aug 2019 14:38:50 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:references:user-agent:from:to:cc:subject:in-reply-to:date
 :message-id:mime-version:content-transfer-encoding;
 bh=HFnfli43wglQwn7laOd9NpQQRz5NQhWAbPKIiqiHgFE=;
 b=LB3iM76H0fyyPBs0nUDJvbHaegoNfvRa40tJ7Strzb6s1sO9EdRO3xNfIBk/JlM8qV
 wffOOn3UgPSYmPk2BaYx9y2ACUb9kGhjXArZ49N+uq07S6/1XSUpjtTexTvgsaFgY/WI
 8HweZWdZggLl8dF3vRwpIvLsxI9OhPlawkdq0tToi5puh5bzwD3vw96kKwoNHpUdwJfz
 xEtyhjpHGwApSNKZt46YjIgozRNA5dW8kvoykJZbh8CHP82NFAAv6Mg+SwR6SPxAAj1w
 2K/aFu1XhAAyMphBI8cfDnGGjoaDynIuILlxHjdl8mnNTXLyhS3k75cl8JXnB50+EkE4
 UzLA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:references:user-agent:from:to:cc:subject
 :in-reply-to:date:message-id:mime-version:content-transfer-encoding;
 bh=HFnfli43wglQwn7laOd9NpQQRz5NQhWAbPKIiqiHgFE=;
 b=aqjpKqQhJ5MZNvoNRaFCIDhhfFp3KsE+Zp9pDMnbMV93Y9nLdkUOTnlTnbKZ1No5y5
 mO58EnvzPw386nmujKYEokFoG8bELz6R94aZO77IhL+muTDrJu9JY6ugoeuKl6ZwECDK
 8QRdpRSnV4E7IVAkduetMYK2OJLRkaxquBO5hH77YnfBZnyLO30qBZFXPYPUEGj+wMSJ
 myoRBATqGnBWjA34PnHHlRnWwT3V6Ox0jlol7D2HKuo9zlIa2FWbzZOcjfmtGZGaEvmg
 4xdyX3bb2oUqMmm25mxTcXpR2QUPhXyDO6JFADrPR8tVqLg8wSYIj9Zj+ok6YxTtNkJo
 0gwQ==
X-Gm-Message-State: APjAAAUR14eXQxGYgHx5am+xD+xHfV8eT6UT03MxUYuAfShjk8OcH9Sb
 sbqx6lqZsZ1ZqHxH654Tlak9Ax/NfG8=
X-Google-Smtp-Source: APXvYqxiN8j4gpaTd6O77cMkvSUI6i2103x+VTUoMgTxizvqpKtKgQMmu89290Fm5rw8lKfLx5o9jg==
X-Received: by 2002:ac8:4691:: with SMTP id g17mr6889012qto.104.1566596324795; 
 Fri, 23 Aug 2019 14:38:44 -0700 (PDT)
Received: from gusbrs-laptop (ip-32-2-52-196.nyc.us.northamericancoax.com.
 [196.52.2.32])
 by smtp.gmail.com with ESMTPSA id o27sm1996781qkm.37.2019.08.23.14.38.42
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Fri, 23 Aug 2019 14:38:43 -0700 (PDT)
References: <87d0hufamm.fsf@HIDDEN> <87ftlsfp3v.fsf@HIDDEN>
 <87h8688233.fsf@HIDDEN> <874l27btck.fsf@HIDDEN> <83d0gvk5m0.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.2
From: Gustavo Barros <gusbrs.2016@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#36830: 26.2;
 find-file-visit-truename is not honored as file local variable
In-reply-to: <83d0gvk5m0.fsf@HIDDEN>
Date: Fri, 23 Aug 2019 18:38:40 -0300
Message-ID: <87y2zj1s0v.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 36830
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 36830 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Hi Eli, Hi Lars,

On Fri, Aug 23 2019, Eli Zaretskii wrote:

>> From: Lars Ingebrigtsen <larsi@HIDDEN>
>> Date: Fri, 23 Aug 2019 20:59:55 +0200
>> Cc: 36830 <at> debbugs.gnu.org
>>=20
>>       (if find-file-visit-truename
>> 	  (setq buffer-file-name (expand-file-name=20
>> buffer-file-truename)))
>>=20
>> [...]
>>=20
>> 	(after-find-file error (not nowarn)))
>>=20
>> `after-find-file' is the function that interprets the file local
>> variables, so we're setting the buffer file name before we've set=20
>> that
>> variable locally.
>>=20
>> One option would be to re-check the variable after `after-find-file',
>> but that seems a bit hacky.
>>=20
>> Any opinions?
>
> I don't think this variable was designed to be set from file-local
> variables block.  Visiting a file and naming its buffer are two racy
> actions, and where there's a race there will be chicken-and-egg type
> of problems.
>
>> --- a/lisp/files.el
>> +++ b/lisp/files.el
>> @@ -2413,7 +2413,11 @@ find-file-noselect-1
>>  	    (setq buffer-file-coding-system 'no-conversion)
>>  	    (set-buffer-major-mode buf)
>>  	    (setq-local find-file-literally t))
>> -	(after-find-file error (not nowarn)))
>> +	(after-find-file error (not nowarn))
>> +        ;; In case `find-file-visit-truename' is set as a file-local
>> +        ;; variable, recompute the buffer file name.
>> +        (when find-file-visit-truename
>> +	  (setq buffer-file-name (expand-file-name=20
>> buffer-file-truename))))
>
> I expect such renaming to cause future bugs, FWIW.  Or maybe not, but
> this is beyond hacky, IMO.
>
> Maybe we should just document that this variable cannot be file-local.

I admittedly reported this from a user perspective, and do not fully=20
grasp what is going on in this case.  But I think I can add something=20
here if I point that `vc-follow-symlinks` does work as a file local=20
variable.  Maybe I=E2=80=99m wrong in comparing these two variables, but if=
 not,=20
this could both provide some approach that works for this purpose, and=20
could perhaps reduce the concerns raised by Eli.

I may also add that I would hardly set `find-file-visit-truename`=20
globally, but I would find it useful locally (I don=E2=80=99t claim to be a=
ny=20
reference in this respect though).  Furthermore, if the race mentioned=20
by Eli does prove to be insurmountable, and if there is any difference=20
between setting this as "file-local" or as "dir-local", the latter could=20
prove useful even if the former could not be maintained.  (I don=E2=80=99t =
know=20
if dir-local variables are set before the file is actually visited, but=20
that is what I have in mind in mentioning this.  If that is the case,=20
the race might be thus circumvented.)

Best,
Gustavo.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 23 Aug 2019 20:07:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 23 16:07:49 2019
Received: from localhost ([127.0.0.1]:41243 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1i1Fqf-00086w-3l
	for submit <at> debbugs.gnu.org; Fri, 23 Aug 2019 16:07:49 -0400
Received: from eggs.gnu.org ([209.51.188.92]:45469)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1i1Fqd-00086g-3e
 for 36830 <at> debbugs.gnu.org; Fri, 23 Aug 2019 16:07:47 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49470)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1i1FqY-00006u-0i; Fri, 23 Aug 2019 16:07:42 -0400
Received: from [176.228.60.248] (port=4106 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1i1FqX-00046j-GX; Fri, 23 Aug 2019 16:07:41 -0400
Date: Fri, 23 Aug 2019 23:07:51 +0300
Message-Id: <83d0gvk5m0.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <874l27btck.fsf@HIDDEN> (message from Lars Ingebrigtsen on Fri, 
 23 Aug 2019 20:59:55 +0200)
Subject: Re: bug#36830: 26.2;
 find-file-visit-truename is not honored as file local variable
References: <87d0hufamm.fsf@HIDDEN> <87ftlsfp3v.fsf@HIDDEN>
 <87h8688233.fsf@HIDDEN> <874l27btck.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36830
Cc: 36830 <at> debbugs.gnu.org, gusbrs.2016@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Date: Fri, 23 Aug 2019 20:59:55 +0200
> Cc: 36830 <at> debbugs.gnu.org
> 
>       (if find-file-visit-truename
> 	  (setq buffer-file-name (expand-file-name buffer-file-truename)))
> 
> [...]
> 
> 	(after-find-file error (not nowarn)))
> 
> `after-find-file' is the function that interprets the file local
> variables, so we're setting the buffer file name before we've set that
> variable locally.
> 
> One option would be to re-check the variable after `after-find-file',
> but that seems a bit hacky.
> 
> Any opinions?

I don't think this variable was designed to be set from file-local
variables block.  Visiting a file and naming its buffer are two racy
actions, and where there's a race there will be chicken-and-egg type
of problems.

> --- a/lisp/files.el
> +++ b/lisp/files.el
> @@ -2413,7 +2413,11 @@ find-file-noselect-1
>  	    (setq buffer-file-coding-system 'no-conversion)
>  	    (set-buffer-major-mode buf)
>  	    (setq-local find-file-literally t))
> -	(after-find-file error (not nowarn)))
> +	(after-find-file error (not nowarn))
> +        ;; In case `find-file-visit-truename' is set as a file-local
> +        ;; variable, recompute the buffer file name.
> +        (when find-file-visit-truename
> +	  (setq buffer-file-name (expand-file-name buffer-file-truename))))

I expect such renaming to cause future bugs, FWIW.  Or maybe not, but
this is beyond hacky, IMO.

Maybe we should just document that this variable cannot be file-local.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 23 Aug 2019 19:00:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 23 15:00:03 2019
Received: from localhost ([127.0.0.1]:41196 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1i1En4-00068o-Vb
	for submit <at> debbugs.gnu.org; Fri, 23 Aug 2019 15:00:03 -0400
Received: from quimby.gnus.org ([80.91.231.51]:51104)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1i1En2-000688-3L
 for 36830 <at> debbugs.gnu.org; Fri, 23 Aug 2019 15:00:01 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1i1Emx-0001cj-TC; Fri, 23 Aug 2019 20:59:58 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Gustavo Barros <gusbrs.2016@HIDDEN>
Subject: Re: bug#36830: 26.2; find-file-visit-truename is not honored as
 file local variable
References: <87d0hufamm.fsf@HIDDEN> <87ftlsfp3v.fsf@HIDDEN>
 <87h8688233.fsf@HIDDEN>
Date: Fri, 23 Aug 2019 20:59:55 +0200
In-Reply-To: <87h8688233.fsf@HIDDEN> (Gustavo Barros's message of "Fri, 23
 Aug 2019 10:04:48 -0300")
Message-ID: <874l27btck.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Gustavo Barros <gusbrs.2016@HIDDEN> writes: > Sure. The
 file from which I reported, and which I include here now, was > just a dummy
 file with the variable of interest set to true with >
 `add-file-local-variable`:
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36830
Cc: 36830 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Gustavo Barros <gusbrs.2016@HIDDEN> writes:

> Sure. The file from which I reported, and which I include here now, was 
> just a dummy file with the variable of interest set to true with 
> `add-file-local-variable`:

Thanks; I'm able to reproduce the bug in Emacs 27, too.

I'm not sure what the fix is, though.  Here's how it's set:

(defun find-file-noselect-1 (buf filename nowarn rawfile truename number)

[...]

      (if find-file-visit-truename
	  (setq buffer-file-name (expand-file-name buffer-file-truename)))

[...]

	(after-find-file error (not nowarn)))

`after-find-file' is the function that interprets the file local
variables, so we're setting the buffer file name before we've set that
variable locally.

One option would be to re-check the variable after `after-find-file',
but that seems a bit hacky.

Any opinions?

diff --git a/lisp/files.el b/lisp/files.el
index f76635017d..bde8a466d0 100644
--- a/lisp/files.el
+++ b/lisp/files.el
@@ -2413,7 +2413,11 @@ find-file-noselect-1
 	    (setq buffer-file-coding-system 'no-conversion)
 	    (set-buffer-major-mode buf)
 	    (setq-local find-file-literally t))
-	(after-find-file error (not nowarn)))
+	(after-find-file error (not nowarn))
+        ;; In case `find-file-visit-truename' is set as a file-local
+        ;; variable, recompute the buffer file name.
+        (when find-file-visit-truename
+	  (setq buffer-file-name (expand-file-name buffer-file-truename))))
       (current-buffer))))
 
 (defun insert-file-contents-literally (filename &optional visit beg end replace)


-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 23 Aug 2019 13:05:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 23 09:05:00 2019
Received: from localhost ([127.0.0.1]:39311 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1i19FU-0006c2-FM
	for submit <at> debbugs.gnu.org; Fri, 23 Aug 2019 09:05:00 -0400
Received: from mail-io1-f41.google.com ([209.85.166.41]:39823)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gusbrs.2016@HIDDEN>) id 1i19FS-0006bn-7i
 for 36830 <at> debbugs.gnu.org; Fri, 23 Aug 2019 09:04:58 -0400
Received: by mail-io1-f41.google.com with SMTP id l7so19916034ioj.6
 for <36830 <at> debbugs.gnu.org>; Fri, 23 Aug 2019 06:04:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:references:user-agent:from:to:cc:subject:in-reply-to:date
 :message-id:mime-version;
 bh=pBdgXNSQK9pwOnvJFs4dlMYv0tEfGqVyC2G1usDi7Jc=;
 b=fPu/m3yLsFBp6YTzPhOEz0K/MX8xKn3W9ceUEOUblgNr0/2EkeFSSyY3Lj21n4YmyB
 oorEwgVFRMDVAI62O65HsDdm41auKtzeEC+c7iCnUJ0Ovnhy2kZtdPoCU0dfgoForNWi
 cLFOEBKzZ0eD5QaNiiNwf1AVu1qx+9Iyu0QpbiA4FLRnBzBqM5RFQg8lRB9X0wv/lE3z
 noEU7e5fMvNWt/IzjiSNeFzd/rCdHdPxi+sQoo4TWULy8ZnbxDWWwjq4guo27TZ1KtuX
 ScroaLB8AdzfaebWpcXhrFx4Wmd+v9C4Q4A2qaoDw+IFV4AreRU/QlYOBmVIq5b8w/9K
 LeIA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:references:user-agent:from:to:cc:subject
 :in-reply-to:date:message-id:mime-version;
 bh=pBdgXNSQK9pwOnvJFs4dlMYv0tEfGqVyC2G1usDi7Jc=;
 b=U6jkYrbO1cXhW3B81UqJvWTbbOKB/FJUQsZYgBWMIuGqw4QQeFJI1KC208ufwMiT58
 bYwHszyN7FuCdUtQlccehwY4x0COcXafnwrsWTykWHBXcuF6KH5cm6FerbcvekQJI1QC
 s/zeU9Nfz2AwXj0n/1NPXfikE5be5O0DzqAz6YbpaKENgXjpDAE2wIZ0myx8yi2TbIH1
 SFwxlLRNmhmg5BgNNDVh9pfCMMbs6mh6B+AuZRglNVSfYGQTOvQMD5YXf4UnijZdXoB6
 X7TOJppucOtCWXXCl8iQziwemTQpLCciVgxtrLYddbTy/spD2ifWQM+Ge8USXLpuAqS2
 6rUQ==
X-Gm-Message-State: APjAAAVgSrHHYI306Q6UCzVG4l9Z6TyBkg4rrkQMcuHw57+ugvh+lpPq
 4xvpRrYHArg8cBDGPqzgvG39hClr12g=
X-Google-Smtp-Source: APXvYqzaoXixktWbjpL6o6DL0YXzc4vD1TKnW1LRulGVohU9S8bCjYaRoyB+f4ivWbbvnafZ7eDZHA==
X-Received: by 2002:a6b:7217:: with SMTP id n23mr6770780ioc.194.1566565491852; 
 Fri, 23 Aug 2019 06:04:51 -0700 (PDT)
Received: from gusbrs-laptop (189.59.182.124.dynamic.adsl.gvt.net.br.
 [189.59.182.124])
 by smtp.gmail.com with ESMTPSA id h9sm2551409ior.9.2019.08.23.06.04.49
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Fri, 23 Aug 2019 06:04:50 -0700 (PDT)
References: <87d0hufamm.fsf@HIDDEN> <87ftlsfp3v.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.2
From: Gustavo Barros <gusbrs.2016@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#36830: 26.2;
 find-file-visit-truename is not honored as file local variable
In-reply-to: <87ftlsfp3v.fsf@HIDDEN>
Date: Fri, 23 Aug 2019 10:04:48 -0300
Message-ID: <87h8688233.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 36830
Cc: 36830 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable


Hi Lars,

thank you for looking into this.

On Fri, Aug 23 2019, Lars Ingebrigtsen wrote:

>
> Could you include the contents of this file?

Sure. The file from which I reported, and which I include here now, was=20
just a dummy file with the variable of interest set to true with=20
`add-file-local-variable`:

#+name: TargetFile.txt
#+begin_example

;; Local Variables:
;; find-file-visit-truename: t
;; End:
#+end_example

(Also in annex)

As I send you this now, I realize I should perhaps have chosen some=20
other file format for the report, as text-mode does not have a=20
predefined comment syntax. I don=E2=80=99t know if this is relevant to the =
local=20
variables machinery. I suppose it isn=E2=80=99t, as my initial issue with t=
his=20
arose in Org files, for which the comment syntax is clear. But if some=20
adjustments on the report for a more proper setting are somehow=20
desired/relevant, let me know.

Best regards,
Gustavo.



--=-=-=
Content-Type: text/plain
Content-Disposition: attachment; filename=TargetFile.txt


;; Local Variables:
;; find-file-visit-truename: t
;; End:

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at 36830 <at> debbugs.gnu.org:


Received: (at 36830) by debbugs.gnu.org; 23 Aug 2019 05:05:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 23 01:05:46 2019
Received: from localhost ([127.0.0.1]:38860 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1i11li-0000h9-AF
	for submit <at> debbugs.gnu.org; Fri, 23 Aug 2019 01:05:46 -0400
Received: from quimby.gnus.org ([80.91.231.51]:40556)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1i11lf-0000h0-JU
 for 36830 <at> debbugs.gnu.org; Fri, 23 Aug 2019 01:05:45 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1i11lc-0003zH-HS; Fri, 23 Aug 2019 07:05:42 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Gustavo Barros <gusbrs.2016@HIDDEN>
Subject: Re: bug#36830: 26.2; find-file-visit-truename is not honored as
 file local variable
References: <87d0hufamm.fsf@HIDDEN>
Date: Fri, 23 Aug 2019 07:05:40 +0200
In-Reply-To: <87d0hufamm.fsf@HIDDEN> (Gustavo Barros's message of "Sun, 28
 Jul 2019 12:21:21 -0300")
Message-ID: <87ftlsfp3v.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Gustavo Barros <gusbrs.2016@HIDDEN> writes: >
 `find-file-visit-truename`
 is defined in "files.el" and is included > there as a safe-local-variable
 (as long as boolean). However, its use > as a file local variable does not
 seem to be honored. > [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 36830
Cc: 36830 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Gustavo Barros <gusbrs.2016@HIDDEN> writes:

> `find-file-visit-truename` is defined in "files.el" and is included 
> there as a safe-local-variable (as long as boolean).  However, its use 
> as a file local variable does not seem to be honored.
>
> Steps to reproduce.
>
> Consider a scenario with the following directory tree:
>
> #+begin_example
> ~/
> ~/FolderA/
> ~/FolderA/TargetFile.txt
> ~/FolderB/
> ~/FolderB/LinkToTargetFile.txt -> ~/FolderA/TargetFile.txt
> #+end_example
>
> "~/FolderA/TargetFile.txt" has `find-file-visit-truename` set to true as 
> a file local variable.

Could you include the contents of this file?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 28 Jul 2019 15:21:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 28 11:21:32 2019
Received: from localhost ([127.0.0.1]:46999 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hrkzL-0007Wg-QM
	for submit <at> debbugs.gnu.org; Sun, 28 Jul 2019 11:21:32 -0400
Received: from lists.gnu.org ([209.51.188.17]:46754)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <gusbrs.2016@HIDDEN>) id 1hrkzK-0007WZ-3B
 for submit <at> debbugs.gnu.org; Sun, 28 Jul 2019 11:21:30 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:53951)
 by lists.gnu.org with esmtp (Exim 4.86_2)
 (envelope-from <gusbrs.2016@HIDDEN>) id 1hrkzI-0005yb-KE
 for bug-gnu-emacs@HIDDEN; Sun, 28 Jul 2019 11:21:30 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.1 required=5.0 tests=BAYES_50,
 FREEMAIL_ENVFROM_END_DIGIT,FREEMAIL_FROM,URIBL_BLOCKED autolearn=disabled
 version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <gusbrs.2016@HIDDEN>) id 1hrkzH-00010i-3J
 for bug-gnu-emacs@HIDDEN; Sun, 28 Jul 2019 11:21:28 -0400
Received: from mail-qt1-x843.google.com ([2607:f8b0:4864:20::843]:45677)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <gusbrs.2016@HIDDEN>)
 id 1hrkzG-00010I-Vh
 for bug-gnu-emacs@HIDDEN; Sun, 28 Jul 2019 11:21:27 -0400
Received: by mail-qt1-x843.google.com with SMTP id x22so52353081qtp.12
 for <bug-gnu-emacs@HIDDEN>; Sun, 28 Jul 2019 08:21:26 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:user-agent:from:to:subject:date:message-id:mime-version
 :content-transfer-encoding;
 bh=BpLVkM8IqXjfIA5ZIyZ5Qmv3muTMtgqMeYijqa8O9dQ=;
 b=WRglEizw+PP0b0c4ZZHmuoouwawR/vVGeHkIJ2wONBjXyvoxDweRMzCpmG28uiAWAW
 C8lHouyZbgolByFaD2rK89L4qSXill2DIqddTgr2T3tqneUs4Vmki5oFRb8vd7l6vNlb
 lVZE3IETQQy1GENbynFSkIZDRV4JXQ84RL+2Gce/544W/HG2i2gMS37yCveQpqfP7MmA
 2MYBbs2S28j+UuJfUgASeWC9wr24YA09xqYS/7A2Pff7YRvAk0eMFLpzHCvFFP3882L1
 J5etv4M4fddQstfXbC5sQtz/R36SIUvhAdrXGIdRF0hyGXxaVeo8Evp+wopOkl3bnOxU
 1hcw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:user-agent:from:to:subject:date
 :message-id:mime-version:content-transfer-encoding;
 bh=BpLVkM8IqXjfIA5ZIyZ5Qmv3muTMtgqMeYijqa8O9dQ=;
 b=TXpOHBCOBnpCyvFv8jjc2MiyAwO4/XXELmdIxDJ6NVdUO96LGTMAy3TpKFd8ZFi/fM
 wqvBBriVxImPeg1g0YvFbZfYeOBNfKZVKDhNMaemHfaH3v9KK3a6KhD3uj/0gJwwwAnr
 FHrBJ/b/nUyM71QAQzTb6fgN192inXke97jKdPwl+PlqSUxZARW4iKfdnml6OoHXzEF1
 a+167bebpYOeswb0OWVbcIKvC0qYnaWEm5hI/GCAG6G8D+vmATk33D6EuxGDhHQx1cKV
 TJc6Yj5dOFjsGqqGyumsoRAswWMaRqABy+WoJ20IvS2O38ZwgwmNfENtCt+C0Xl3Be02
 94Pg==
X-Gm-Message-State: APjAAAVBKgLzcWA/CPh+lqprOH7mRZZrgXzaZpIopZF7QZQYNGz7+xI9
 vLLx/r+ZkaWn5zgz/vtpS0Ko2lwHqkU=
X-Google-Smtp-Source: APXvYqw0/0LQ6DgawA+zBH01GAc2Tnb8kNrvdPcCrAJe6Fq6V407aq7aJlus9z14v4JGnR+SsFdNYg==
X-Received: by 2002:ac8:36b9:: with SMTP id a54mr75702540qtc.300.1564327285989; 
 Sun, 28 Jul 2019 08:21:25 -0700 (PDT)
Received: from gusbrs-laptop (ip-68-2-52-196.nyc.us.northamericancoax.com.
 [196.52.2.68])
 by smtp.gmail.com with ESMTPSA id h18sm23365499qkj.134.2019.07.28.08.21.23
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 28 Jul 2019 08:21:25 -0700 (PDT)
User-agent: mu4e 1.2.0; emacs 26.2
From: Gustavo Barros <gusbrs.2016@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 26.2; find-file-visit-truename is not honored as file local variable
Date: Sun, 28 Jul 2019 12:21:21 -0300
Message-ID: <87d0hufamm.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2607:f8b0:4864:20::843
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

Hi all,

`find-file-visit-truename` is defined in "files.el" and is included=20
there as a safe-local-variable (as long as boolean).  However, its use=20
as a file local variable does not seem to be honored.

Steps to reproduce.

Consider a scenario with the following directory tree:

#+begin_example
~/
~/FolderA/
~/FolderA/TargetFile.txt
~/FolderB/
~/FolderB/LinkToTargetFile.txt -> ~/FolderA/TargetFile.txt
#+end_example

"~/FolderA/TargetFile.txt" has `find-file-visit-truename` set to true as=20
a file local variable.

Start ~emacs -Q~ and visit "~/FolderB/LinkToTargetFile.txt".

Eval ~(buffer-file-name)~ and the result is:=20
"~/FolderB/LinkToTargetFile.txt" (substituted home folder). Whereas=20
=3D(file-truename (buffer-file-name))=3D reports "~/FolderA/TargetFile.txt"=
,=20
which would be the expected visited file, given the local file variable.


Best regards,
Gustavo Barros.

PS: I=E2=80=99ve asked about this elsewhere=20
(https://emacs.stackexchange.com/q/51495/18951). But, since then,=20
investigating this further, and considering this works for=20
`vc-follow-symlinks` (which is being discussed at=20
https://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D33264), I came to think=20
this indeed might be unexpected behavior. Thus this report.




In GNU Emacs 26.2 (build 1, x86_64-pc-linux-gnu, GTK+ Version 3.22.30)
 of 2019-04-19 built on gusbrs-laptop
Windowing system distributor 'The X.Org Foundation', version=20
11.0.11906000
System Description:	Linux Mint 19.1 Tessa

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.
Making completion list...
"/home/gustavo/FolderB/LinkToTargetFile.txt"
Making completion list...
"/home/gustavo/FolderA/TargetFile.txt"
Configured using:
 'configure --with-mailutils --with-xwidgets --with-modules'

Configured features:
XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK SOUND GPM DBUS GSETTINGS GLIB
NOTIFY ACL LIBSELINUX GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB
TOOLKIT_SCROLL_BARS GTK3 X11 XDBE XIM MODULES THREADS XWIDGETS
LIBSYSTEMD LCMS2

Important settings:
  value of $LC_MONETARY: pt_BR.UTF-8
  value of $LC_NUMERIC: pt_BR.UTF-8
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Text

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny seq byte-opt gv
bytecomp byte-compile cconv cl-loaddefs cl-lib dired dired-loaddefs
format-spec rfc822 mml easymenu mml-sec password-cache epa derived epg
epg-config gnus-util rmail rmail-loaddefs mm-decode mm-bodies mm-encode
mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047
rfc2045 ietf-drums mm-util mail-prsvr mail-utils elec-pair time-date
mule-util tooltip eldoc electric uniquify ediff-hook vc-hooks
lisp-float-type mwheel term/x-win x-win term/common-win x-dnd tool-bar
dnd fontset image regexp-opt fringe tabulated-list replace newcomment
text-mode elisp-mode lisp-mode prog-mode register page menu-bar
rfn-eshadow isearch timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core term/tty-colors frame cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray minibuffer
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote threads dbusbind
inotify lcms2 dynamic-setting system-font-setting font-render-setting
xwidget-internal move-toolbar gtk x-toolkit x multi-tty
make-network-process emacs)

Memory information:
((conses 16 96167 6183)
 (symbols 48 20414 1)
 (miscs 40 54 104)
 (strings 32 28445 1315)
 (string-bytes 1 748145)
 (vectors 16 14078)
 (vector-slots 8 502466 7254)
 (floats 8 51 146)
 (intervals 56 523 0)
 (buffers 992 13))




Acknowledgement sent to Gustavo Barros <gusbrs.2016@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#36830; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 14 Oct 2019 21:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.